
import grease
import random
import pymunk
import pyglet

def offset(pos, off):
    return (pos[0] + off[0], pos[1] + off[1],)
        

class CranePart(grease.Entity):
    def __init__(self, world, position, angle, parent, static=False):

        
    
        self.position.position = position
        self.position.angle = angle
        if static:
            img = "cranebase.png"
            verts = [(0,0), (32,0), (32,16) , (0,16) ]
            anchor = 16, 8
        else:
            img = "cranepart.png"
            #verts = [(-8,-32),(8,-8), (8,64-16) , (0,64) ]
            anchor = (1000, -64/2 + 8)
            
        self.sprite.type = "Crane"
        image = pyglet.resource.image(img )
        self.sprite.sprite = pyglet.sprite.Sprite(image)
        self.sprite.sprite.anchor = anchor

        verts = [   
                    ( self.sprite.sprite.width/2,-self.sprite.sprite.height/2),
                    (-self.sprite.sprite.width/2,-self.sprite.sprite.height/2),
                    (-self.sprite.sprite.width/2, self.sprite.sprite.height/2),
                    ( self.sprite.sprite.width/2, self.sprite.sprite.height/2),
                    ]
        self.shape.verts = verts

        self.physics.colltype="Poly"
        world.systems.physics.add(self, static)

        self.renderable.color = "#0ff"
        
        if parent is not None:
            anchor = (0, -64/2 + 8)
            self.physics.shape.group = 1
            parent.physics.shape.group = 1
            rotation_center_joint = pymunk.PinJoint(    
                self.physics.body, 
                parent.physics.body, 
                anchor, 
                (0, parent.sprite.sprite.height/2 - 8)
                )
            print self, offset(anchor, self.physics.body.position)
            print self, offset(anchor, self.physics.body.position), "parent"
            self.world.systems.physics.space.add(rotation_center_joint)
            
        
class Crane(grease.Entity):
    
    def __init__(self, world, position, angle):

        self.position.position = position
        self.position.angle = angle

        self.craneparts.parts = []
        
        base  = CranePart(world, offset(position, (0,-24)), angle, None, static=True)
        part1 = CranePart(world, offset(position, (0,0)), angle, base)
        part2 = CranePart(world, offset(position, (0,64-16)), angle, part1)
        part3 = CranePart(world, offset(position, (0,(64-16)*2)), angle, part2)
        part4 = CranePart(world, offset(position, (0,(64-16)*3)), angle, part3)
        
        #self.craneparts.parts.append(base)
        self.craneparts.parts.append(part1)
        self.craneparts.parts.append(part2)
        
        
        
        
class CraneSystem(grease.System):

    def __init__(self, world):
        pass

    def step(self, dt):
        for entity in self.world[Crane].entities:
            #print entity
            entity.doAI(dt)
            
