
import grease
import pyglet


class Net(grease.Entity):
    COLLIDE_INTO_MASK = 0b10
    def __init__(self, world, position):

        self.position.position = position
        self.movement.velocity = (0,0)
        img = pyglet.resource.image("net.png")
        
        img.anchor_x = img.width/2
        img.anchor_y = img.height/2
        sprite = pyglet.sprite.Sprite(img)
        
        w = img.width
        h = img.height
        #self.shape.verts = [(-w/2, -h/2), (-w/2, h/2), (w/2, h/2), (w/2, -h/2)]
        #self.renderable.color = "#f00"
        
        self.sprite.type = "Net"
        self.sprite.sprite = sprite
        

        #self.world.clock.schedule_once(self.start_countdown, 3.5)

        
        self.fishing.captured_fishes = []
        
        self.collision.radius = w/2 * 0.7
        self.collision.from_mask = 0b01
        self.collision.into_mask = self.COLLIDE_INTO_MASK
        
    
    def on_collide(self, other, point, normal):
        print "captured a fish!", other
        other.captured()
        #other.delete()
        self.fishing.captured_fishes.append(other)
        
        green_to_catch = self.world.systems.game.green_to_catch
        red_to_catch = self.world.systems.game.red_to_catch
        
        for f in self.fishing.captured_fishes:
            if f.sprite.type == "GreenFish":
                green_to_catch -= 1
            elif f.sprite.type == "RedFish":
                red_to_catch -= 1
        #print green_to_catch, red_to_catch
        if green_to_catch <= 0 and red_to_catch <= 0:
            self.start_countdown()
    
    def start_countdown(self):
        self.world.clock.schedule_interval(self.blink, 0.15)
        self.world.clock.schedule_once(self.collect, 2)
        
        
    def collect(self, dt):
        self.world.clock.unschedule(self.blink)
        self.world.systems.fishing.capture(self)
        #self.sprite.sprite.delete()
        self.delete()
    
    def blink(self, dt):
        self.sprite.sprite.visible = not self.sprite.sprite.visible
        
        
        
        
        
        