import grease
import pyglet
from grease.controls import KeyControls
from grease import renderer, component
from pyglet.window import key

from Renderer import *
from GameScreen import GameScreen
from Const import Globals

class TitleScreen(grease.World):
    """Game title screen world and mode"""

    def configure(self):
        window = Globals.window
        self.components.position = component.Position()
        self.components.shape = component.Shape()
        self.components.renderable = component.Renderable()
        
        self.renderers.background = Background()
        self.renderers.camera = renderer.Camera(position=(window.width / 2, window.height / 2))

        self.renderers.title = pyglet.text.Label(
            "Net, Set and FISH",
            color=(150, 150, 255, 255),
            font_name='Vector Battle', font_size=32, bold=True,
            x=0, y=50, anchor_x='center', anchor_y='bottom')
        self.renderers.description = pyglet.text.Label(
            "A fishing game",
            color=(150, 150, 255, 255),
            font_name='Vector Battle', font_size=16, bold=True,
            x=0, y=20, anchor_x='center', anchor_y='top')
        self.renderers.one_player = pyglet.text.Label(
            "Click to begin",
            color=(150, 150, 255, 255),
            font_name='Vector Battle', font_size=16, bold=True,
            x=0, y=-100, anchor_x='center', anchor_y='top')
            
        
        self.systems.controls = TitleScreenControls()

class TitleScreenControls(KeyControls):
    """Title screen key event handler system"""

    def on_mouse_press(self, x, y, button, modifiers):
        print "start game!"
        Globals.window.push_mode(GameScreen())
        
    @KeyControls.key_press(key.ESCAPE)
    def start_single_player(self):
        print "1"
        Globals.window.pop_mode()