import os
import sys


currpath = os.getcwd()
sys.path.insert(0, os.path.join( currpath, "pyglet-1.1.4" ) )
sys.path.insert(0, os.path.join( currpath, "grease-0.2" ) )


import pyglet
import grease

from grease import mode

pyglet.resource.path = [os.path.join("../data/")]
pyglet.resource.reindex()
pyglet.options['debug_gl'] = False

from TitleScreen import TitleScreen
from GameScreen import GameScreen

from Const import Globals
def run():
    """Initialize and run the game"""
    global window
    window = mode.ManagerWindow(width=1024, height=600, caption="Net, Set and FISH" )
    Globals.window = window
    window.push_mode(TitleScreen())
    #window.push_mode(GameScreen())
    pyglet.app.run()



if __name__ == "__main__":
    do_profile = 0
    if do_profile == 1:
        import profile
        import cProfile, pstats
        cProfile.run("run()", "main")
        stats = pstats.Stats( "main" )
        stats.strip_dirs()
        stats.sort_stats('time', 'calls')
        stats.print_stats(30)
    if do_profile == 2:
        import profile
        profile.run("run()")
    else:
        run()